// Cordier Yves 
// le 27/10/2018
/* *****************************************************************************
   Dans une application, devant afficher une image en respectant la transparence
   i.e. ne dessiner que les pixels significatifs (dont la couleur est différente 
   de celle d'une couleur de fond déclarée, et las de faire des essais infructueus 
   avec la fonction tint qui ne fait que mélanger harmonieuesement les images
   j'ai développé la petite fonction ci dessous pour afficher une image en 
   mode tampon (sur un tampon si on travaille sans être trop butte, on ne trace
   que les surépaisseurs du tampon et non le fond).
   
   On ne dessine que les pixelx de couleur différents de ceux de la couleur dite de 
   ransparence
*/
void imageStamp(PImage tampon, int x, int y, color transp)
{
  int tx=tampon.width; // histoire d'accelerer les choses
  int ty=tampon.height; // et de rendre plus lisible le code
  int maxi=tx*ty; // la taille maxi du buffer linéaire pour stocker l'image (index de 0 à maxi-1)
  color c; // variable de stockage interne
  int pos; // index interne
  PImage imInit=get(x, y, tx, ty); // on recupere l'image initiale de dessous
  // on balaie la totalité du tableau linéaire représentant les pixels 
  pos=0;
  for (int i=0; i<maxi; i++)
  {
    // si la couleur de l'image tampon n'est pas transparente, on la met
    if ((c=tampon.pixels[pos])!=transp) // l'opération (c=tampon.pixels[pos]) est ici pour gagner du temps
	/* en effet en C C++ ou java toute opération renvoi une valeur dans l'accumulateur
	   (ou équivalent) du processeur. Libre à nous de l'affecter, de l'utiliser ... Mais on
	   peut tres bien faire les deux 
	*/ 
    {
      imInit.pixels[pos]=c;
    }
    pos++; // on avance d'un pixel
  }
  /* 
  
  la version suivante est moins efficace
  for (int i=0; i<maxi; i++)
  {
    if (tampon.pixels[pos]!=transp)
	{
      imInit.pixels[pos]=tampon.pixels[pos]; 
    }
    pos++; // on avance d'un pixel
  }
  
  celle-ci encore moins (difficile de faire pire ..
  
  for (int j=0; i<ty; j++)
  {
    for (int i=0; i<tx; i++)
		{
			if (tampon.pixels[j*tx+i]!=transp)
				{
				imInit.pixels[j*tx+i]=tampon.pixels[j*tx+i]; 
				}
		}
  }
  */
  
  image(imInit, x, y); // on remet l'image en place sur l'ensemble
}
