
// Petit programme de manipulation de zones graphiques
// Les zones images
// Cordier Yves
// Le 26/10/2018

/*  Nota : 
 Utilise les unités logicielles DefCouleur et AddImage
 Les copier dans le répertoire du programme principal
 */
 
PImage imMire; // La mire proprement dite
PImage imSto; // le stokage de la zone image avant tracé de la mire
PImage imFond; // l'Image de fond d'écran 
// La taille de la mire (diametre)
int tailleMire=100;

// pour utiliser les couleurs prédéterminées dans l'unité DefCouleur
Couleur coul=new Couleur();

// *****************************************************************************
// Creation de la mire 

void creeMire()

{
  // Le point central au centre de l'écran
  int xmid=width/2;
  int ymid=height/2;
  // stockage de la zone graphique avant trace (variable locale
  PImage imStoCreation=get(xmid-tailleMire/2, ymid-tailleMire/2, tailleMire, tailleMire); // prise des pixels ecran avant
  noStroke();
  // trace du fond neutre;
  fill(coul.gris); 
  rect(xmid-tailleMire/2, ymid-tailleMire/2, tailleMire, tailleMire);

  //Tracé de la mire 
  // on trace
  fill(coul.bleu); // le fond
  noStroke(); // pas de tour !!
  ellipse(xmid, ymid, tailleMire-2, tailleMire-2); // tracé de la mire

  fill(coul.rouge); // autre fond
  ellipse(xmid, ymid, tailleMire/2, tailleMire/2); // tracé de la mire

  fill(coul.gris); // encore un autre
  ellipse(xmid, ymid, tailleMire/4, tailleMire/4); // tracé de la mire

  stroke (coul.blanc); // traits en blanc
  strokeWeight(1); // taille des traits
  // Les traits
  line(xmid, ymid-(tailleMire/2-1), xmid, ymid+(tailleMire/2-1));
  line(xmid-(tailleMire/2-1), ymid, xmid+(tailleMire/2-1), ymid);
  noFill(); // pas de remplissage
  // Les cercles concentriques
  ellipse(xmid, ymid, tailleMire-2, tailleMire-2); 
  ellipse(xmid, ymid, tailleMire*3/4, tailleMire*3/4); 
  ellipse(xmid, ymid, tailleMire/2, tailleMire/2); 
  ellipse(xmid, ymid, tailleMire/4, tailleMire/4); 

  // on stoke la mire réalisée
  imMire=get(xmid-tailleMire/2, ymid-tailleMire/2, tailleMire, tailleMire); // prise de l'image à balader : la mire

  // on remet la zone graphique à l'initial
  image(imStoCreation, xmid-tailleMire/2, ymid-tailleMire/2); // on "efface" ce que l'on a tracé
}

// =========================================================
// Procedure standard d'initialisation

void setup()
{
  size(1200, 650);
  // affichage de l'image de fond stockée dans le repertoire data
  imFond=loadImage("fond.jpg"); // charge l'objet monImage avec les données du fichier qui doit se trouver dans
  // le répertoire data
  // on dessine l'image c'est à dire que on decode les données et que l'on dessine pixel par pixel
  // sur la fenètre graphique
  image(imFond, 0, 0); // on l'installe à partir de la position x,y 0,0

  // on enregistre l'écran avant le trace de la mire
  imSto=get(xc, yc, tailleMire, tailleMire); // prise des pixels ecran avant
  // creation de la mire
  creeMire();
  imageStamp(imMire, xc, yc, coul.gris); // on affiche la mire au point initial
}

// ============================================================
// variables de position du coin haut gauche de la mire
int xprec=0;
int yprec=xprec;
int xsuiv=xprec;
int ysuiv=xprec;
int xc=xprec;
int yc=yprec;
// parametres de fluidité du mouvement
int num=0;
int maxMvmt=20;

// ============================================================
// procedure principale

void draw()
{
  if (num>=maxMvmt) // on genere le mouvement suivant
  {
    // actualisation
    xprec=xsuiv;
    yprec=ysuiv;
    int nb;
    // calcul du nouveau point
    do
    {
      xsuiv=int(random(imFond.width)-tailleMire/2);
      ysuiv=int(random(imFond.height)-tailleMire/2);
    }
    while (20>(nb=int(sqrt(sq(xsuiv-xprec)+sq(ysuiv-yprec))))); // mouvement de 20 pixels mini
    num=0; // on réinitialise pour le trajet suivant
    maxMvmt=nb/5; // calcul du nombre d'images intermediaires
    if (maxMvmt==0) maxMvmt=2; // par securité
  } 

  // on avance doucement vers la nouvelle place
  num++; // gestion des micros-pas   on va du pas N°1 au pas N°maxMvmt
  image(imSto, xc, yc); // on remet l'ancienne image
  // calcul de la position actuelle
  xc=(xsuiv-xprec)/maxMvmt*num+xprec;
  yc=(ysuiv-yprec)/maxMvmt*num+yprec;

  // on recupere l'image sous la mire
  PImage imRecup= get(xc, yc, tailleMire, tailleMire); 
  // on affiche la zone amplifiée facteur 2 au coin en bas à gauche de la zone graphique
  image(imRecup, 1200-225, 650-225, 200, 200);

  // on affiche une zone amplifiée par 4
  PImage imFois4=get(1200-225+50, 650-225+50, 100, 100); // on recupère l'image déja amplifiée
  image(imFois4, 1200-225, 650-225-250, 200, 200); // on la réamplifie


  imSto=get(xc, yc, tailleMire, tailleMire); // on sauve la zone ou l'on va placer la nouvelle mire
  imageStamp(imMire, xc, yc, coul.gris); // on affiche la mire à la bonne position en préservant l'image initiale
}
